/*
 *  soapUI, copyright (C) 2004-2007 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */
package com.eviware.soapui.impl.wsdl.support.xsd;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.xml.namespace.QName;

import com.eviware.soapui.SoapUI;
import com.eviware.soapui.support.types.StringList;

public class SettingUtils
{
   public static Collection<? extends QName> string2QNames(String excluded)
   {
      List<QName> result = new ArrayList<QName>();
      if( excluded != null && excluded.trim().length() > 0 )
      {
         try
         {
            StringList names = StringList.fromXml( excluded );
            for( String name : names )
            {
               int ix = name.indexOf( '@' );
               if(ix >= 0)
                  result.add( new QName( name.substring( ix+1 ), name.substring( 0, ix )));
               else
                  result.add( new QName( name ) );
            }
         }
         catch( Exception e )
         {
            SoapUI.logError( e );
         }
      }
      
      return result;
   }
}
